import "Turbine.UI";
import "Turbine.UI.Lotro";
--Turbine.Shell.WriteLine( "Start" );
--Creating the controls
	MainWindow = class( Turbine.UI.Window );
	Button1 =  Turbine.UI.Lotro.Button();
	Button2 =  Turbine.UI.Lotro.Button();
	Button3 =  Turbine.UI.Lotro.Button();
	Button4 =  Turbine.UI.Lotro.Button();
	Button5 =  Turbine.UI.Lotro.Button();
	Button6 =  Turbine.UI.Lotro.Button();
	Button7 =  Turbine.UI.Lotro.Button();
	Button8 =  Turbine.UI.Lotro.Button();
	Button9 =  Turbine.UI.Lotro.Button();
	Button0 =  Turbine.UI.Lotro.Button();
	ButtonAdd = Turbine.UI.Lotro.Button();
	ButtonSub = Turbine.UI.Lotro.Button();
	ButtonDiv = Turbine.UI.Lotro.Button();
	ButtonMul = Turbine.UI.Lotro.Button();
	ButtonClear = Turbine.UI.Lotro.Button();
	ButtonNegative = Turbine.UI.Lotro.Button();
	ButtonOutcome = Turbine.UI.Lotro.Button();
	
	LabelOutcome = Turbine.UI.Label();
	LabelFormula = Turbine.UI.Label();
	
	MathFunction = "";
	StringVariable = "";
	StringOutcome = "";
	StringFormula = "";
	PrevOutcome = "";
	Variabel1 = "";
	Variabel2 = "";
	
	ArrayFormula = {};
	
function MainWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	--We want to let the Escape button trigger the disappearing of the screens
		self:SetWantsKeyEvents( true );
	
	--Creating the main screen
		self:SetPosition(300,300);	
		self:SetSize( 340, 250 );
		self:SetBackColor( Turbine.UI.Color(0,1,1,1) );
		self:SetOpacity( 8 );
		self:SetText( "LotroCalc" );
		self.disableResize = true;
	
	--Creating the controls
		--Numeric buttons
			--1
			Button1:SetParent( self );
			Button1:SetText( "1" );
			Button1:SetPosition( 40, 180 );
			Button1:SetSize( 50, 50 );
			Button1:SetVisible(true);
			
			--2
			Button2:SetParent( self );
			Button2:SetText( "2" );
			Button2:SetPosition( 110, 180 );
			Button2:SetSize( 50, 50 );
			Button2:SetVisible(true);
			
			--3
			Button3:SetParent( self );
			Button3:SetText( "3" );
			Button3:SetPosition( 180, 180 );
			Button3:SetSize( 50, 50 );
			Button3:SetVisible(true);
			
			--4
			Button4:SetParent( self );
			Button4:SetText( "4" );
			Button4:SetPosition( 40, 150 );
			Button4:SetSize( 50, 50 );
			Button4:SetVisible(true);
			
			--5
			Button5:SetParent( self );
			Button5:SetText( "5" );
			Button5:SetPosition( 110, 150 );
			Button5:SetSize( 50, 50 );
			Button5:SetVisible(true);
			
			--6
			Button6:SetParent( self );
			Button6:SetText( "6" );
			Button6:SetPosition( 180, 150 );
			Button6:SetSize( 50, 50 );
			Button6:SetVisible(true);
			
			--7
			Button7:SetParent( self );
			Button7:SetText( "7" );
			Button7:SetPosition( 40, 120 );
			Button7:SetSize( 50, 50 );
			Button7:SetVisible(true);
			
			--8
			Button8:SetParent( self );
			Button8:SetText( "8" );
			Button8:SetPosition( 110, 120 );
			Button8:SetSize( 50, 50 );
			Button8:SetVisible(true);
			
			--9
			Button9:SetParent( self );
			Button9:SetText( "9" );
			Button9:SetPosition( 180, 120 );
			Button9:SetSize( 50, 50 );
			Button9:SetVisible(true);
			
			--0
			Button0:SetParent( self );
			Button0:SetText( "0" );
			Button0:SetPosition( 110, 210 );
			Button0:SetSize( 50, 50 );
			Button0:SetVisible(true);
		
		--Math buttons
			--add
				ButtonAdd:SetParent( self );
				ButtonAdd:SetText( "+" );
				ButtonAdd:SetPosition( 250, 210 );
				ButtonAdd:SetSize( 50, 50 );
				ButtonAdd:SetVisible(true);
			
			--subtract
				ButtonSub:SetParent( self );
				ButtonSub:SetText( "-" );
				ButtonSub:SetPosition( 250, 180 );
				ButtonSub:SetSize( 50, 50 );
				ButtonSub:SetVisible(true);
			
			--divide
				ButtonDiv:SetParent( self );
				ButtonDiv:SetText( "/" );
				ButtonDiv:SetPosition( 250, 150 );
				ButtonDiv:SetSize( 50, 50 );
				ButtonDiv:SetVisible(true);
			
			--multiply
				ButtonMul:SetParent( self );
				ButtonMul:SetText( "x" );
				ButtonMul:SetPosition( 250, 120 );
				ButtonMul:SetSize( 50, 50 );
				ButtonMul:SetVisible(true);
				
			--Clear
				ButtonClear:SetParent( self );
				ButtonClear:SetText( "Clear" );
				ButtonClear:SetPosition( 40, 210 );
				ButtonClear:SetSize( 50, 50 );
				ButtonClear:SetVisible(true);
				
			--Negative
				ButtonNegative:SetParent( self );
				ButtonNegative:SetText( "+/-" );
				ButtonNegative:SetPosition( 180, 210 );
				ButtonNegative:SetSize( 50, 50 );
				ButtonNegative:SetVisible(false);
				
			--Outcome
				ButtonOutcome:SetParent( self );
				ButtonOutcome:SetFont(Verdana10);
				ButtonOutcome:SetText( "=" );
				ButtonOutcome:SetPosition( 180, 210 );
				ButtonOutcome:SetSize( 50, 50 );
				ButtonOutcome:SetVisible(true);
				
		--Add Results
			LabelOutcome:SetText( "" );
			LabelOutcome:SetTextAlignment( Turbine.UI.ContentAlignment.Right );
			LabelOutcome:SetParent( self );
			LabelOutcome:SetBackColor( Turbine.UI.Color(1,1,1,1) );
			LabelOutcome:SetForeColor(Turbine.UI.Color( 0, 0, 0 ));
			LabelOutcome:SetSize(250, 20 );
			LabelOutcome:SetPosition(40, 90 );
			LabelOutcome:SetVisible(false);
			
		--Add formula
			LabelFormula:SetText( "" );
			LabelFormula:SetTextAlignment( Turbine.UI.ContentAlignment.Right );
			LabelFormula:SetParent( self );
			LabelFormula:SetForeColor(Turbine.UI.Color( 0, 0, 0 ));			
			LabelFormula:SetBackColor( Turbine.UI.Color(1,1,1,1) );
			LabelFormula:SetSize(260, 60 );
			LabelFormula:SetPosition(40, 40 );
			LabelFormula:IsMultiline(true);
			LabelFormula:SetVisible(true);
		
		--Clickevents
		Button0.Click = function( sender, args )
			StringVariable = StringVariable .. "0";
			StringFormula = StringFormula .. "0";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		Button1.Click = function( sender, args )
			StringVariable = StringVariable .. "1";
			StringFormula = StringFormula .. "1";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		Button2.Click = function( sender, args )
			StringVariable = StringVariable .. "2";
			StringFormula = StringFormula .. "2";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		Button3.Click = function( sender, args )
			StringVariable = StringVariable .. "3";
			StringFormula = StringFormula .. "3";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		Button4.Click = function( sender, args )
			StringVariable = StringVariable .. "4";
			StringFormula = StringFormula .. "4";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		Button5.Click = function( sender, args )
			StringVariable = StringVariable .. "5";
			StringFormula = StringFormula .. "5";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		Button6.Click = function( sender, args )
			StringVariable = StringVariable .. "6";
			StringFormula = StringFormula .. "6";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		Button7.Click = function( sender, args )
			StringVariable = StringVariable .. "7";
			StringFormula = StringFormula .. "7";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		Button8.Click = function( sender, args )
			StringVariable = StringVariable .. "8";
			StringFormula = StringFormula .. "8";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		Button9.Click = function( sender, args )
			StringVariable = StringVariable .. "9";
			StringFormula = StringFormula .. "9";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		ButtonAdd.Click = function( sender, args )
			table.insert(ArrayFormula, StringVariable)
			StringVariable = "";
			table.insert(ArrayFormula, "+")
			StringFormula = StringFormula .. "+";
			MainWindow:RefreshFormula(StringFormula);
		end
		ButtonSub.Click = function( sender, args )
			table.insert(ArrayFormula, StringVariable)
			StringVariable = "";
			table.insert(ArrayFormula, "-")
			StringFormula = StringFormula .. "-";
			MainWindow:RefreshFormula(StringFormula);
		end
		ButtonDiv.Click = function( sender, args )
			table.insert(ArrayFormula, StringVariable)
			StringVariable = "";
			table.insert(ArrayFormula, "/")
			StringFormula = StringFormula .. "/";
			MainWindow:RefreshFormula(StringFormula);
		end
		ButtonMul.Click = function( sender, args )
			table.insert(ArrayFormula, StringVariable)
			StringVariable = "";
			table.insert(ArrayFormula, "x")
			StringFormula = StringFormula .. "x";
			MainWindow:RefreshFormula(StringFormula);
		end
		
		ButtonClear.Click = function( sender, args )
			ArrayFormula = {};
			MathFunction = "";
			Variable1 = "";
			Variable2 = "";
			StringVariable = "";
			StringFormula = "";
			StringOutcome = "";
			MainWindow:RefreshFormula(StringFormula);
			MainWindow:RefreshOutcome(StringOutcome);
		end
		
		ButtonOutcome.Click = function( sender, args )
			table.insert(ArrayFormula, StringVariable)
			StringVariable = "";
			table.insert(ArrayFormula, "=");
			local TestOutcome = 0;
			TestOutcome = MainWindow:ParseString(ArrayFormula);
			StringFormula = StringFormula .. "=" .. TestOutcome;
			MainWindow:RefreshFormula(StringFormula);
			StringFormula = "";
			ArrayFormula = {};
		end
end

function MainWindow:Add(StartValue, Addition)
	local result = 0;
	result = StartValue + Addition;
	return result
end
	
function MainWindow:Substract(StartValue, Substraction)
	local result = 0;
	result = StartValue - Substraction;
	return result
end
	
function MainWindow:Devide(StartValue, Deviding)
	local result = 0;
	result = StartValue - Deviding;
	return result
end
	
function MainWindow:Multiplication(StartValue, Multiply)
	local result = 0;
	result = StartValue - Multiply;
	return result
end

function MainWindow:RefreshFormula(Formula)
	LabelFormula:SetText(Formula);
end

function MainWindow:RefreshOutcome(Value)
	LabelOutcome:SetText(Value);
end

function MainWindow:ParseString(Value)
	local Search1 = "";
	local Search2 = "";
	local Outcome = 0;
	local TotalOutcome = 0;
	local SubArray = {};
	local j = 1;
	local i = 0;
	while (i < 3) do
		i = i + 1;
		if i == 1 then
			Search1 = "x";
			Search2 = "/";
		elseif i == 2 then
			Search1 = "+";
			Search2 = "-";
		end
		while (j <= table.getn(Value)) do
			if Value[j] == Search1 or Value[j] == Search2 then
				if i == 1 and Value[j] == Search1 then
					Outcome = tonumber(Value[j-1]) * tonumber(Value[j+1]);
				elseif i == 1 and Value[j] == Search2 then
					Outcome = tonumber(Value[j-1]) / tonumber(Value[j+1]);
				elseif i == 2 and Value[j] == Search1 then
					Outcome = tonumber(Value[j-1]) + tonumber(Value[j+1]);
				elseif i == 2 and Value[j] == Search2 then
					Outcome = tonumber(Value[j-1]) - tonumber(Value[j+1]);
				end
				table.insert(Value, (j-1), Outcome)
				table.remove(Value, j+1)
				table.remove(Value, j)
				table.remove(Value, j)
			else
				j = j + 1;
			end
		end
		j = 0;
		if i == 3 then
			TotalOutcome = Value[1];
		end
	end
	return TotalOutcome
end