import "LotroCalc"

LotroCalc = MainWindow();
LotroCalc:SetVisible( true );
-- create a new command line command for the travel window
	CalcCommand = Turbine.ShellCommand();

-- handle the travel commands
function CalcCommand:Execute( command, arguments )
	if ( arguments == "show" ) then
		LotroCalc:SetVisible( true );
		Preview:SetVisible( true );
	elseif ( arguments == "hide" ) then
		LotroCalc:SetVisible( false );
		Preview:SetVisible( true );
	elseif ( arguments == "toggle" ) then
		LotroCalc:SetVisible( not LotroCalc:IsVisible() );
		Preview:SetVisible( not Preview:IsVisible()  );
	elseif ( arguments == "dump" ) then
		LotroCalc:DoDump();
	elseif ( arguments ~= nil ) then
		CalcCommand:GetHelp();
	end
end

function CalcCommand:GetHelp()
	Turbine.Shell.WriteLine( "LotroCalc help \n" .. 
	"/LotroCalc show : to show the window \n" ..
	"/LotroCalc hide : to hide the window \n" ..
	"/LotroCalc toggle : to toggle the window" );
end

-- add the command to the shell
Turbine.Shell.AddCommand( "LotroCalc", CalcCommand );